namespace Pr19;

public abstract class Libro
{
    public string Isbn { get; private set; }
    
    public string Titolo { get; private set; }
    
    public string Autore { get; private set; }

    private double prezzoCopertina;
    public double PrezzoCopertina
    {
        get { return prezzoCopertina; }
        private set
        {
            if (value < 0)
                prezzoCopertina = 0;
            else
                prezzoCopertina = value;
        }
    }

    public Libro(string isbn, string titolo, string autore, double prezzoCopertina)
    {
        Isbn = isbn;
        Titolo = titolo;
        Autore = autore;
        PrezzoCopertina = prezzoCopertina;
    }

    public abstract double PrezzoVendita();

    public abstract override string ToString();
}